package healthwatcher.view.command;

import healthwatcher.Constants;
import healthwatcher.model.healthguide.MedicalSpeciality;
import healthwatcher.view.IFacade;

import java.io.PrintWriter;

import lib.exceptions.InvalidSessionException;
import lib.exceptions.ObjectNotFoundException;
import lib.patterns.CommandReceiver;
import lib.util.HTMLCode;
import lib.util.IteratorDsk;

import healthwatcher.aspects.concurrency.annotations.*;

public class UpdateMedicalSpecialityList extends CommandServlet {

	@ExecuteCommandEvent
	public void executeCommand(CommandReceiver receiver) {

		PrintWriter out = response.getWriter();

		try {

			if (! request.isAuthorized()) {
				throw new InvalidSessionException("Invalid Session! <br><a href=\"" + Constants.SYSTEM_LOGIN + "\">Try again</a>");
			}

			IteratorDsk repTP = ((IFacade) receiver).getSpecialityList();

			out.println("Queries - Medical Speciality information");
			out.println("<body><h1>Queries:<br>Querie about medical specialities</h1>");
			out.println("<p>Choose a speciality: </p>");
			out.println("<form method=\"POST\" action=\""+Constants.SYSTEM_ACTION+"?operation=UpdateMedicalSpecialitySearch\">");

			out.println("<div align=\"center\"><center><p><select name=\"specialityCode\" size=\"1\">");
			
			if (repTP == null || !repTP.hasNext()) {
				out.println("</select></p></center></div>");
				out.println("<p><font color=\"red\"><b> There isn't any medical speciality.</b></font></p>");
			} else {
				MedicalSpeciality speciality;
				do {
					speciality = (MedicalSpeciality) repTP.next();
					out.println("<option value=\"" + speciality.getCodigo() + "\"> "
							+ speciality.getDescricao() + " </OPTION>");
				} while (repTP.hasNext());
				repTP.close();

				out.println("</select></p></center></div>");
				out.println("  <div align=\"center\"><center><p><input type=\"submit\" value=\"Search\" name=\"B1\"></p></center></div></form>");
			}
			out.println(HTMLCode.closeAdministrator());
		} catch (ObjectNotFoundException e) {
			out.println("There isn't any medical speciality");
		} catch (InvalidSessionException e) {
			out.println(e.getMessage());
		}
	}

}
