package lib.persistence;

import lib.exceptions.RepositoryException;
import lib.exceptions.TransactionException;

import healthwatcher.aspects.persistence.annotations.*;

public interface IPersistenceMechanism {

	public void connect() throws RepositoryException;

	public void disconnect() throws RepositoryException;

	public Object getCommunicationChannel() throws RepositoryException;

	public void releaseCommunicationChannel() throws RepositoryException;
	
	@TransactionExEvent
	public void beginTransaction() throws TransactionException;

	@TransactionExEvent
	public void commitTransaction() throws TransactionException;

	@TransactionExEvent
	public void rollbackTransaction() throws TransactionException;
}
